from app import db, socketio
from app.events import connected_sessions
from app.models import Corpus
from flask import current_app, request
from flask_login import login_required
from .CQiWrapper.CQiWrapper import CQiWrapper
import logging
import time


@socketio.on('init_corpus_analysis')
@login_required
def init_corpus_analysis(corpus_id):
    logger = logging.getLogger(__name__)
    logger.warning('init_corpus_analysis')
    ''' TODO: Check if current_user is allowed to subscribe to this '''
    socketio.start_background_task(observe_corpus_analysis_connection,
                                   current_app._get_current_object(),
                                   corpus_id,
                                   request.sid)


@socketio.on('query_event')
def recv_query(message):
    logger = logging.getLogger(__name__)
    logger.warning(message)


def observe_corpus_analysis_connection(app, corpus_id, session_id):
    logger = logging.getLogger(__name__)
    with app.app_context():
        time.sleep(5)  # wait for IP of container only for dev
        corpus = Corpus.query.filter_by(id=corpus_id).first()
        logger.warning('IP adress is: {}'.format(corpus.analysis_container_ip))
        cqi_session = CQiWrapper(username='opaque', password='opaque',
                                 host=corpus.analysis_container_ip, port=4877)
        cqi_session.connect()
        logger.warning(cqi_session.corpus_list_corpora())
        corpus_name = 'CORPUS'
        result_subcorpus_name = 'Query-results'  # should be set by the user somehow
        query = '"and";'
        cqi_session.create_attribute_strings(corpus_name)
        logger.warning('Log after create_attribute_strings.')
        cqi_session.query_subcorpus(corpus_name, result_subcorpus_name, query)
        logger.warning('Log after query_subcorpus.')
        while session_id in connected_sessions:
            logger.warning('Run container, run!')
            socketio.sleep(3)
        corpus.status = 'stop analysis'
        db.session.commit()
        logger.warning('Stop container, stop!')
